unit base;
 {$IFDEF FPC}
  {$MODE DELPHI} {$H+}
{$ENDIF}
(***************************************)
(* Copyright (C) 2009, SHIRAISHI Kazuo *)
(***************************************)



interface
uses  Classes, StdCtrls, ComCtrls,  SysUtils, Graphics, inifiles,
      sconsts;
const
   MinInt=-maxint-1;
type
   tpPrecision=(PrecisionNormal,PrecisionHigh,PrecisionNative,PrecisionComplex,PrecisionRational);
const
   PrecisionText:array[tpPrecision]of AnsiString=(s_decimal,s_1000digits,s_Binary,s_complex,s_rational);
   PrecisionLiteral:array[tpPrecision]of AnsiString=('DECIMAL','DECIMAL_HIGH','NATIVE','COMPLEX','RATIONAL');
type
   IOOption=(ioReadWrite,ioCharacterByte,ioSkipRest,ioWhenInside,ioClear,ioNoWait);
   IOOptions=set of IOOption;
type
    tpRecordSetter=(rsNone,rsBEGIN,rsEND,rsNEXT,rsSAME);
type
    AccessMode=(amOUTIN,amINPUT,amOUTPUT);
    RecordType=(rcDISPLAY,rcINTERNAL,rcCSV);
    OrganizationType=(orgSEQ,orgSTREAM);
(*
const
   AccessModeCode:array[AccessMode]of string=('amOUTIN','amINPUT','amOUTPUT');
   RecordTypeCode:array[RecordType]of string =('rcDISPLAY','rcINTERNAL');
   OrganizationTypeCode:Array[OrganizationType] of string =('orgSEQ','orgSTREAM');
*)
const
    AccessModeLiteral:array[AccessMode]of AnsiString=('OUTIN','INPUT','OUTPUT');
    RecordTypeLiteral:array[RecordType] of ansistring =('DISPLAY','INTERNAL','CSV');
    OrganizationTypeLiteral:array[OrganizationType] of Ansistring=('SEQUENTIAL','STREAM');
    YesNoLiteral:array[false..true]of AnsiString=('NO','YES');

type
  TypBmpSize=(BMPpc9801,BMPdosv,BMP321,BMP401,BMP501,BMP641,BMP801,BMP1001,BMP1281,BMP1601,BMP2001);
var
   BmpSize:TypBmpSize=BMP641;
const
   BMPSizeLiteral:array[TypBMPSize] of ansistring=
         ('BMPpc9801','BMPdosv','BMP321','BMP401','BMP501','BMP641','BMP801','BMP1001','BMP1281','BMP1601','BMP2001');

var      initialESP:cardinal;
function stacksize1:integer;assembler;
var      StackLimit1:integer=$1000000;


type
    EExtype=class(Exception)
       extype:integer;
      constructor create;overload ;
      constructor create(i:integer);overload ;
    end;

var
   extype :integer      =0;
procedure setexception(t:integer);
procedure setexceptionwith(const s:string; t:integer);
type
   TStatusMes=class(TStringList)
       function add(const s:string):integer;override;
       function murge:string;
       function murgeWithOR:string;
       procedure insert(const s:string);
   end;
var
   statusmes:TStatusmes;



const
      outofmemory=-100;
      StackOverflow=-101;
      VirtualStackOverflow=-102;
      ArraySizeOverflow=-103;
      GosubStackOverflow=-104; {For Code Gen. Only}
      TextOverFlow=-108;
      SystemErr=-109;

var
   GraphMode:boolean=false;
   TextMode:boolean=false;
   KeepGraphic:boolean=false;
   KeepText:boolean=false;
   UseCharInput:boolean=false;
   InitialPrecisionMode0:tpPrecision=PrecisionNative;
   InitialPrecisionMode:tpPrecision=PrecisionNative;
   PrecisionMode :tpPrecision=PrecisionNative;
   initialOptionBase:byte=1;
   initialAngleDegrees:boolean=false;
   initialCharacterByte0:boolean=true;
   initialCharacterByte:boolean=true;
   JISFormat:boolean=false;
   JISSetWindow:boolean=true;
   JISDim:boolean=false;
   JISDef:boolean=false;
   ForNextBroadOwn:boolean=false;
   UseTranscendentalFunction:boolean=false;
   signiwidthMore:boolean=false;
   MinimalBasic:boolean=false;
   PermitMicrosoft:boolean=false;

 type
  TBreakFlags=record
     case integer of
       1: (LongFlag:longbool);
       2: (ctrlBreak:boolean; TraceMode:boolean; TraceChannelPlus1:word);
     end;
var
  BreakFlags:TBreakFlags=(LongFlag:false) ;
  ctrlBreakHit: boolean absolute BreakFlags;

{*****************}
{Utility functions}
{*****************}
function max(a,b:integer):integer; inline;
function min(a,b:integer):integer; inline;
function imod(a,b:integer):integer;
function Spaces(n:integer):ansistring;
function strint(i:longint):string;


//コプロセッサコントロールワード
const
   maxnumber1:array[0..4]of word=($ffff,$ffff,$ffff,$ffff,$7ffe);
var
   maxnumber:extended absolute maxnumber1;
const
   maxnumber2:array[0..3]of word=($ffff,$ffff,$ffff,$7fef);
var
   maxnumberDouble:double absolute maxnumber2;



 {***}
 {FPU}
 {***}
var   controlword:word= $1372; //割り込み許可
var   RoundMost :WORD = $1372; //近い方の値に丸め
var   RoundNins :WORD = $1772; //－∞方向に切り捨て
var   RoundPlus :WORD = $1B72; //＋∞方向に切り上げ
var   RoundZero :WORD = $1F72; //０方向の値に丸め

const
  CharNameTBL1:array[0..39] of string[3] =
           ('NUL','SOH','STX','ETX','EOT','ENQ','ACK','BEL','BS','HT',
            'LF' ,'VT' ,'FF' ,'CR' ,'SO' ,'SI' ,'DLE','DC1','DC2','DC3',
            'DC4','NAK','SYN','ETB','CAN','EM' ,'SUB','ESC','FS' ,'GS' ,
            'RS' ,'US' ,'SP' ,'UND','GRA','LBR','VLN','RBR','TIL','DEL');
  CharNameTBL2:array[0..39] of byte =
           (  0, 1, 2, 3, 4, 5, 6, 7, 8, 9,
             10,11,12,13,14,15,16,17,18,19,
             20,21,22,23,24,25,26,27,28,29,
             30,31,32,95,96,123,124,125,126,127);



function Format17(x:double):String;
function Format20(x:extended):String;

procedure Idle; inline;
procedure IdleImmediately;

{********}
{Ini File}
{********}

 function IniFileName:string;

type
   TMyIniFile=class(TObject)
     Ini:TIniFile;
     section:string;
     readOnly:boolean;
     constructor create(const section1:string);
     destructor  destroy; override;
     function FileName:string;virtual;
     function ReadInteger (const Ident: string; Default: integer): integer;
     function ReadString (const Ident: string; const Default: string): string;
     function ReadBool (const Ident: string; Default: Boolean): Boolean;
     procedure   WriteInteger(const Ident: string; Value: integer);
     procedure   Writestring(const Ident: string; const Value:string);
     procedure   WriteBool(const Ident: string; Value: Boolean);
     procedure   RestoreFont(font: TFont);
     procedure   StoreFont(font: TFont);
   end;

var
  IniFileReadOnly:boolean=false;
var
  NoInitialize:boolean=false;
var
   UseReg:boolean=false;



{++++++++++++}
implementation
{++++++++++++}

uses  Types, Forms,Controls, 
      myutils;

function Format17(x:double):String;
begin
  result:=SysUtils.Format('%.17g', [x]);
end;

function Format20(x:extended):String;
begin
  result:=SysUtils.Format('%.20g', [x]);
end;




function max(a,b:integer):integer;inline;
begin
  if a>b then
     max:=a
  else
     max:=b
end;

function min(a,b:integer):integer;inline;
begin
  if a>b then
     min:=b
  else
     min:=a
end;

function stacksize1:integer;assembler;
asm
   mov    eax,initialESP
   sub    eax,esp
end;


{**************}
{error handling}
{**************}



procedure setexception(t:integer);
begin
  setexceptionwith('',t)
end;

procedure setexceptionwith(const s:string; t:integer);
begin
    if t=0 then exit; // extype 0 を発生ささない
    extype :=t;
    statusmes.add(s);
    raise EExtype.create(t);
end;


function imod(a,b:integer):integer;
var
n:integer;
begin
   if a>=0 then
      imod:=a mod b
   else
      begin
         n:=a mod b;
         if n<>0 then inc(n,b);
         imod:=n
      end;
end;

function Spaces(n:integer):ansistring;
var
  i:integer;
  s:ansistring;
begin
  s:='';
  for i:=1 to n do s:=s+' ';
  Spaces:=s
end;


function strint(i:longint):string;
var
   s:string;
begin
    str(i,s);
    strint:=s
end;




constructor EExtype.create;
begin
  inherited create('');
end;

constructor EExtype.create(i:integer);
begin
  inherited create('extype ' + strint(i));
  extype:=i
end;


{**********}
{TStatusMes}
{**********}

function TStatusMes.add(const s:string):integer;
begin
   if indexof(s)<0 then
      result := inherited add(s)
   else
      result:=-1    ;
end;


function TStatusMes.murge:string;
var
   i:integer;
begin
   if count=0 then
      result:=''
   else
   begin
     result:=strings[0];
     for i:=1 to count-1 do
      result:=result +EOL+ strings[i];
   end;
end;

function TStatusMes.murgeWithOR:string;
var
   i:integer;
begin
   if count=0 then
      result:='Syntax Error'
   else
   begin
     result:=strings[0];
     for i:=1 to count-1 do
      result:=result +s_or + strings[i];
   end;
end;


procedure TStatusMes.insert(const s:string);
begin
   if count=0 then
      add(s)
   else
      strings[0]:=s +EOL + strings[0]
end;


{****}
{Idle}
{****}
var IdleCount:byte=0;

procedure Idle; inline;
begin
  inc(idlecount);
  if idleCount=0 then
       IdleImmediately;
end;

procedure IdleImmediately;
begin
    Application.ProcessMessages;
    Set8087CW(controlword);
end;


{********}
{INI File}
{********}


function IniFileName:string;
begin
{$IFDEF Win32}
   result:= ChangeFileExt(Application.ExeName,'.ini')
{$ELSE}
   result:=GetEnvironmentVariable('HOME') +'/.'+ ChangeFileExt( ExtractFileName(Application.ExeName), '.ini' )
{$ENDIF}
end;

function TMyIniFile.FileName:string;
begin
   result:=inifileName;
end;

constructor TMyIniFile.create(const section1:string);
begin
   inherited create;
   Ini:=TIniFile.create(FileName);
   section:=section1;
   ReadOnly:=NoInitialize or IniFileReadOnly;
end;

destructor TMyIniFile.destroy;
begin
   if Ini<>nil then ini.free;
   inherited destroy;
end;


function TMyIniFile.ReadInteger (const Ident: string; Default: integer): integer;
begin
  if ini<>nil then
    result:=ini.ReadInteger(section,ident,default)
end;

function TMyIniFile.ReadString (const Ident: string; const Default: string): string;
begin
   if ini<>nil then
    result:=ini.ReadString(section,ident,default)
end;

function TMyIniFile.ReadBool (const Ident: string; Default: Boolean): Boolean;
begin
  if ini<>nil then
    result:=ini.ReadBool(section,ident,default)
end;

procedure   TMyIniFile.WriteInteger(const Ident: string; Value: integer);
begin
   if not readonly then
     if ini<>nil then
      try
       ini.WriteInteger(section,ident,value)
      except
      end
end;

procedure   TMyIniFile.Writestring(const Ident: string; const Value:string);
begin
   if not readonly then
     if ini<>nil then
       try
        ini.WriteString(section,ident,value)
       except
       end
end;

procedure   TMyIniFile.WriteBool(const Ident: string; Value: Boolean);
begin
   if not readonly then
     if ini<>nil then
      try
       ini.WriteBool(section,ident,value)
      except
      end
end;

procedure   TMyIniFile.RestoreFont(font: TFont);
begin
 with font do
   begin
      Charset:=TFontCharset(ReadInteger('FontCharset',Ord(charset)));
      //Height:=ReadInteger('FontHeight',Height);
      Name:=ReadString('FontName',Name);
      Size:=ReadInteger('FontSize',Size);
      //Pitch:=TFontPitch(ReadInteger('FontPitch',Ord(Pitch)));
      //Weight:=ReadInteger('FontWeight',Weight);
      style:=[];
   end;
end;

procedure   TMyIniFile.StoreFont(font: TFont);
begin
  with font do
   begin
      WriteInteger('FontCharset',Ord(charset));
      //WriteInteger('FontHeight',Height);
      WriteString('FontName',Name);
      WriteInteger('FontSize',Size);
      //WriteInteger('FontPitch',Ord(Pitch));
      //WriteInteger('FontWeight',Weight);
   end;
end;








{+++++++++++++}
initialization
{+++++++++++++}
  {
  asm
      FSTCW  controlword0
  end;
  }
  {$IFDEF Windows}
  controlword:=get8087CW;
  {$ENDIF}
  RoundNins:=controlword or $0700; //－∞方向に切り捨て
  RoundPlus:=controlword or $0B00; //＋∞方向に切り上げ
  RoundZero:=controlword or $0F00; //０方向の値に丸め

  statusmes:=TStatusMes.create;

  DecimalSeparator:='.';

 finalization
   statusmes.free;




end.
