unit base0;
 {$IFDEF FPC}
  {$MODE DELPHI} {$H+}
{$ENDIF}
(***************************************)
(* Copyright (C) 2009, SHIRAISHI Kazuo *)
(***************************************)

interface

uses
  Classes, SysUtils,StdCtrls,IniFiles, Graphics,ComCtrls, SynEdit,
  base;

const
   RecordSetterCode:array[tpRecordSetter] of AnsiString=
                                 ('rsNone','rsBEGIN','rsEND','rsNEXT','rsSAME');
const
   IOOptionCode:array[IOOption] of AnsiString=
    ('ioReadWrite','ioCharacterByte','ioSkipRest','ioWhenInside','ioClear','ioNoWait');
function IoOptionsCode(option:IOoptions):Ansistring;


type
   Array4 = array[1..4] of longint;



var
  paramIndex:integer;      //コマンドパラメータのindex；実行中はプログラムファイル名の位置をさす。


var
   pass     :integer    =0;
   exline   :integer    =0;
   expos    :integer    =0;
   exinsertcount:integer=0;
   helpContext:integer  =0;



const
    bkCancel=0;
    bkStep=1;
    bkContinue=2;
var
    bkDirective:integer=bkCancel;
var
   ForceFunctionDeclare:boolean=false;
   InsertDIMst:boolean=false;
   OptionExplicit:boolean=false;
   AutoIndent:boolean=true;
const
   ac_let=0;
   ac_input=1;
   ac_using=2;
   ac_next=3;
   ac_string=4;
   ac_remark=5;
   ac_exp=6;
   ac_while=7;
   ac_multi=8;
   ac_end=9;
var
   AutoCorrect:array[0..ac_end]of boolean=(true,true,true,true,true,true,false,false,false,false);
var
   shift_F5:string='LET ';
   shift_F6:string='PRINT ';
   shift_F7:string='OPTION ANGLE DEGREES';
   shift_F8:string='';
var
  TranslatingNow:boolean=false;
var
  NoRun:boolean=false;
  OpenAndRun:boolean=false;
  NoBackUp:boolean=true;


procedure SelectLine(memo:TSynEdit;i:integer);

var
   HideSyntaxMenu:boolean=false;

procedure  upper(var s:string);
procedure  lower(var s:string);





procedure InitializeEnv;


function TruthLiteral(s:boolean):String;

var
   UseMassArrays:boolean=false;
   SystemStackSize:Cardinal={$IFDEF Windows}$4000000{64MB}{$ELSE} $3FE0000{63.875MB}{$ENDIF};
   VirtualStackSize:Cardinal=$40000000{1024MB};

   OptimizeInteger:boolean=false;
   OptimizeOnlyWhenSubscripts:boolean=true;
   OptimizeDouble:boolean=true;
var
   originalCW:word;

implementation

uses  Types, Forms,Controls,
      {$IFDEF windows}Windows,{$ENDIF}
      {$IFDEF LINUX} Linux,{$ENDIF}
      sconsts,myutils;

procedure  upper(var s:string);
var
     i:integer;
begin
     i:=0;
     while i<length(s) do
        begin
            inc(i);
            if s[i] in ['a'..'z'] then
                   s[i]:=chr(ord(s[i])-32)
            else
                   ReadMBC(i,s); //if IsDBCSLeadByte(byte(s[i])) then inc(i);
        end;
end;

procedure  lower(var s:string);
var
     i:integer;
begin
     i:=0;
     while i<length(s) do
        begin
            inc(i);
            if s[i] in ['A'..'Z'] then
                   s[i]:=chr(ord(s[i])+32)
            else
                   ReadMBC(i,s); //if IsDBCSLeadByte(byte(s[i])) then inc(i);
        end;
end;




{************}
{Editor Utils}
{************}

procedure SelectLine(memo:TSynEdit;i:integer);
var
  p,q:integer;
begin
    with memo do
      begin
         (memo.owner as TForm).BringToFront;
         //SelStart:=SendMessage(Handle,EM_LINEINDEX,i,0);
         p:=LineIndex(memo, i);
         q:=LineIndex(memo, i+1);
         SelStart:=p;
         SelectLine;   //SelLength:=q-p -Length(EOL);
      end;
 end;





{*************}
{generate code}
{*************}
function IoOptionsCode(option:IOoptions):Ansistring;
var
  op:IoOption;
begin
  result:='';
  for op:=Low(IOOption){ioReadWrite} to High(IOOption) {ioNoWait} do
      if op in option then
         result:=result+IoOptionCode[op]+',';
  if (result<>'') and (result[length(result)]=',') then
     delete(result,length(result),1);
  result:='['+result+']';
end;

function TruthLiteral(s:boolean):String;
begin
   if s then result:=' true ' else result :=' false '
end;


function GetPhysicalMemory:Cardinal;
{$IFDEF WINDOWS}
var
  GlobalMemoryInfo:TMemoryStatus;
begin
  GlobalMemoryStatus( GlobalMemoryInfo);
  GetPhysicalMemory:=GlobalMemoryInfo.dwAvailVirtual ;
end;
{$ELSE}
{$IFDEF LINUX}
var
  info:TSysInfo;
begin
  SysInfo(@info);
  result:=info.totalram;
end;
{$ELSE}
begin
  result:=$80000000 {2048MB};  //dummy
end;
{$ENDIF}
{$ENDIF}


{**********}
{Initialize}
{**********}

procedure ReadIniFile;
var
   IniFile:TMyIniFile;
begin
    IniFile:=TMyIniFile.create('Frame');
    with IniFile do
       begin
         AutoIndent:=ReadBool('AutoIndent',AutoIndent);
         OptionExplicit:=ReadBool('OptionExplicit',OptionExplicit);
         UseMassArrays:=ReadBool('UseMassArrays',UseMassArrays);
         SystemStackSize:=ReadInteger('SystemStackSize',SystemStackSize);
         VirtualStackSize:=ReadInteger('VirtualStackSize',VirtualStackSize);
         shift_F5:=ReadString('Shift_F5',Shift_F5);
         shift_F6:=ReadString('Shift_F6',Shift_F6);
         shift_F7:=ReadString('Shift_F7',Shift_F7);
         shift_F8:=ReadString('Shift_F8',Shift_F8);
         OptimizeInteger:=ReadBool('OptimizeInteger',OptimizeInteger);
         OptimizeDouble:=ReadBool('OptimizeDouble',OptimizeDouble);
       //以下，終了時に書き込まれない項目
         InsertDIMst:=ReadBool('InsertDIM',InsertDIMst);
         InitialOptionBase:=ReadInteger('OptionBase',InitialOptionbase);
         PermitMicrosoft:=ReadBool('Microsoft',PermitMicrosoft);
         MinimalBasic:=ReadBool('MinimalBasic',MinimalBasic);
         NoRun:=ReadBool('NoRun',NoRun);
         IniFileReadOnly:=ReadBool('IniFileReadOnly',IniFileReadOnly);
      end;
     IniFile.free;

end;

procedure WriteIniFile;
var
   IniFile:TMyIniFile;
begin
      IniFile:=TMyIniFile.create('Frame');
      with IniFile do
       begin
          WriteBool('AutoIndent',AutoIndent);
          WriteBool('OptionExplicit',OptionExplicit);
          WriteBool('UseMassArrays',UseMassArrays);
          WriteInteger('SystemStackSize',SystemStackSize);
          WriteInteger('VirtualStackSize',VirtualStackSize);
          WriteString('Shift_F5',Shift_F5);
          WriteString('Shift_F6',Shift_F6);
          WriteString('Shift_F7',Shift_F7);
          WriteString('Shift_F8',Shift_F8);
          WriteBool('OptimizeInteger',OptimizeInteger);
          WriteBool('OptimizeDouble',OptimizeDouble);
       end;
      IniFile.free;

end;

procedure InitializeEnv;
begin
  if Application.MessageBox(PChar(s_InitEnv),AppTitle,mb_OKCANCEL)=IDOk then
  begin
    IniFileReadOnly:=true;
    SysUtils.DeleteFile(IniFileName);
  end;
end;




initialization
  paramIndex:=1;
  while (ParamIndex<=ParamCount) and (copy(ParamStr(paramIndex),1,1)='-')  do
       begin
          if ParamStr(paramIndex)='-NI' then NoInitialize:=true;
          if ParamStr(paramIndex)='-OR' then OpenAndRun:=true;
          if ParamStr(paramIndex)='-NR' then NoRun:=true;
          inc(paramIndex);
       end;

  readIniFile;

  originalCW:=get8087CW;

finalization
  WriteIniFile;


end.

