unit charinp;

{$IFDEF FPC}
  {$MODE DELPHI}{$H+}
{$ENDIF}

(***************************************)
(* Copyright (C) 2003, SHIRAISHI Kazuo *)
(***************************************)


interface

uses
   SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls,
   LResources,
   myutils,base;

type
  TCharInput = class(TForm)
    Label1: TLabel;
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
  public
    c:ansistring;
    TimeLimit:TDateTime;
    LineNumber:integer;
    function execute(option:IOoptions):ansistring;
    procedure init;
  end;

var
  CharInput: TCharInput;

implementation
uses fileutil;
{$R *.lfm}


procedure TCharInput.FormKeyPress(Sender: TObject; var Key: Char);
begin
   c:=c+key;
end;



function TCharInput.execute(option:IOoptions):ansistring;
var
   svCtrlBreakHit:boolean;
   i:integer;
   s:ansistring;
begin
   show;
   svCtrlBreakHit:=CtrlBreakHit;
   CtrlBreakHit:=false;
   IdleImmediately;

   if not(ioNoWait in option) then
      //SelectLine(TextHand.memo,LineNumber);
   //caption:=TextHand.getMemoLine(LineNumber);
   Label1.visible:=true;

   if ioClear in option then
      c:='';

   IdleImmediately;
   While not((ioNoWait in option) or (Length(c)>0) or CtrlBreakHit or (now>=timelimit)) do
     begin
      sleep(10);IdleImmediately;
     end;

   if Length(c)>0 then
      begin
         if ioCharacterByte in option then
           begin
              result:=c[1];
              delete(c,1,1);
           end
         else
            {$IFDEF Windows}
             begin
               i:=1;
               ReadSJIS(i,c);           //Shift JISを読む
               if i<=Length(c) then
                 begin
                   result:=SysToUTF8(copy(c,1,i));
                   delete(c,1,i);
                 end;
            end;
           {$ELSE}
            begin
              i:=1;
              ReadMBC(i,c);
              result:=copy(c,1,i);
              delete(c,1,i);
            end;
           {$ENDIF}
      end
   else
      result:='';
   CtrlBreakHit:=CtrlBreakHit or svCtrlbreakHit;
   //texthand.memo.sellength:=0;
   if not(ioNoWait in option) then
      begin
         hide;
         Label1.visible:=false;
      end;
   //caption:='';
   if (now>=timelimit) then setexception(8401);
end;


procedure TCharInput.FormCreate(Sender: TObject);
begin
   init;
end;

procedure TCharInput.Init;
begin
   c:='';
   Label1.caption:='';
end;

initialization



end.

