{$X+}
unit compiler;
{$IFDEF FPC}
  {$MODE DELPHI} {$H+}
{$ENDIF}
(***************************************)
(* Copyright (C) 2010, SHIRAISHI Kazuo *)
(***************************************)



interface
uses  SysUtils, Classes, Types, Forms, Dialogs, ComCtrls, Controls, Graphics, StdCtrls,
      struct,codefrm;

function Generate(Lines:TStrings):boolean;
function RunCode(CodeForm:TCodeForm):boolean;
procedure ExecuteImmediately;

//procedure RunNormal;
//procedure RunStep;

var
   changedir:procedure;
   setIndentOption:procedure;
   setOperation:procedure;
   setRunOption:procedure;
   setRunOption2:procedure;
   setDebug:procedure;
   setLineEndMarker:procedure;
   setRefferingPath:procedure;
var
   ProgramOnRunning:string='';

implementation

uses
     {$IFDEF Windows}
     windows,shellapi,
     {$ENDIF}
      Process,
     MainFrm,  paintfrm, setpath,  repoform,
     objlist, base,base0,arithmet,
     myutils,texthand,express,statemen,graphic,graphsys,
     optiondg,helpctex,math2sub,sconsts,vstack,memman,merge;

type
  TBackUp=class(TThread)
       text1:ansistring;
       fName:ansistring;
    constructor create(const s,f:AnsiString);
    procedure execute;override;
  end;

constructor TBackUp.create(const s,f:AnsiString);
begin
   inherited create(false);
   text1:=s;
   FName:=f;
end;

procedure TBackUp.execute;
var
  t:Text;
begin
  assignFile(t,fname);
  try
    rewrite(t);
    write(t,text1);
    close(t)
  except
  end;
end;

(*
function MyMessageDlg(const Msg: string; DlgType: TMsgDlgType;
  Buttons: TMsgDlgButtons; HelpCtx: Longint; const Caption1:string): Integer;
begin
  with CreateMessageDialog(Msg, DlgType, Buttons) do
    try
      HelpContext := HelpCtx;
      Caption:=Caption1;
      Result := ShowModal;
    finally
      Free;
    end;
end;
*)

var
    ReCompile:boolean=false;

function compile:boolean;
begin
 Screen.cursor:=crHourGlass;
 compile:=true;
 recompile:=false;
 try
    struct.compile;
 except
   on E:Exception do
      begin
          compile:=false;
          currentprogram.deletestatements; //2011.3.9 追加
          currentprogram.freeall;
          if E is EReCompile then
             recompile:=true
          else if not (E is SyntaxError) then
             ShowMessage(s_internalErrorCompiling+EOL+E.message +EOL+Contact);
      end;
 end;
 Screen.cursor:=crDefault;
end;

function CompilePrg:boolean;
var
   ErrorMes:string;
   svUseTranscendentalFunction:boolean;
begin
   svUseTranscendentalFunction := UseTranscendentalFunction;

   FrameForm.Memo1.lines.BeginUpdate;

   extype:=0;
   InitSeed;

   GraphMode:=false;
   textMode:=false;
   UseCharInput:=false;

   ReCompile:=false;
   repeat

       SetPrecisionMode(InitialPrecisionMode,true);

       indent:=-1;
       USEnest:=0;

       DoStack:=TList.Create;
       ForStack:=TList.create;
       WhenStack:=TList.create;
       WhenStack.add(nil);
       WhenUseStack:=TList.create;
       WhenUseStack.add(nil);

       result:=false;
       pass:=1;

       try
         if compile then
            begin
               pass:=2;
               currentprogram.deletestatements;
               currentprogram.VarTablesRebuild;
               //currentprogram.ShareVarTableGetVar;
               result:=compile;
            end;
       finally
         DoStack.Free;
         ForStack.free;
         WhenStack.free;
         WhenUseStack.free;

         KeyWordTablesFreeAll;
         Pass:=0;
       end;
   until recompile=false;

   FrameForm.Memo1.lines.EndUpdate;
   //  エラーを表示する
   if result=false then
       begin
         SelectLine(FrameForm.memo1,exline);
         //MyMessageDlg(statusmes.murgeWithOR, mtWarning, [mbOK,mbHelp]
         //                                  ,HelpContext,s_SyntaxError);

         ErrorMes:= s_SyntaxError+' at line ' + IntToStr(exline+1)+ EOL +
                     statusmes.murgeWithOR ;
         if HelpContext=0 then
              MessageDlg( ErrorMes, mtWarning, [mbOK],HelpContext)
         else
              MessageDlg( ErrorMes, mtWarning, [mbOK,mbHelp],HelpContext);
         //with FrameForm.memo1 do
           // SelStart:=SendMessage(Handle,EM_LINEINDEX,
           //                       exline,0)+expos+exinsertcount-1;
         with FrameForm do
           Memo1.SelStart:=LineIndex(FrameForm.Memo1,exline)+expos+exinsertcount-1;
         end;

   UseTranscendentalFunction := svUseTranscendentalFunction
end;


procedure SetTranslatingNow(s:boolean);
begin
   TranslatingNow:=s;
   with FrameForm do
      begin
        TBRun.enabled:=not s;
        TBStep.enabled:=not s;
        TBBreak.enabled:=not s;
        TBCut.enabled:=not s;
        TBPaste.enabled:=not s;
        TBUndo.enabled:=not s;
        if not permitMicrosoft then
           begin
              TBDecimal.enabled:=not s;
              TBHighPrecision.enabled:=not s;
              TBBinary.enabled:=not s;
              TBComplex.enabled:=not s;
              TBRational.enabled:=not s;
              TBDeg.enabled:=not s;
           end;
        Option1.enabled:=not s;
        SetUp1.enabled:=not s;
        Window1.enabled:=not s;
        Help1.enabled:=not s;
      end;
   with FrameForm do
    begin
       Run2.enabled:=not s;
       Break1.enabled:=not s;
       Step1.enabled:=not s;
       Exit1.enabled:=not s;
       PopUpRun1.enabled:=not s;
       PopUpBreak1.enabled:=not s;
       PopUpCode1.enabled:=not s;
       //Close1.enabled:=not s;
       merge1.enabled:=not s;
       Cut1.enabled:=not s;
       Paste1.enabled:=not s;
       Delete1.enabled:=not s;
       Undo1.enabled:=not s;
       Repalce1.enabled:=not s;
       deleteLabelNumber1.enabled:=not s;
       addLabelNumber1.enabled:=not s;
       CaseChange1.enabled:=not s;
       ToolBox1.enabled:=not s;
       Memo1.ReadOnly:=s;
   end;
   with CodeForm  do begin
       Run2.enabled:=not s;
       File1.enabled:=not s;
       Edit1.enabled:=not s;
       option1.enabled:=not s;
   end;
   Application.ProcessMessages;
end;

procedure SetExecutingNow(s:boolean);
begin
   with FrameForm do
      begin
        TBRun.enabled:=not s;
        TBStep.enabled:=not s;
        Window1.enabled:=not s;
        Help1.enabled:=not s;
      end;
   with FrameForm do
      begin
       Run2.enabled:=not s;
       Step1.enabled:=not s;
       Exit1.enabled:=not s;
       PopUpRun1.enabled:=not s;
       PopUpCode1.enabled:=not s;
       ToolBox1.enabled:=not s;
      end;
   with CodeForm  do
      begin
       Run2.enabled:=not s;
       File1.enabled:=not s;
       Edit1.enabled:=not s;
       option1.enabled:=not s;
      end;
   With FrameForm do
     begin
       TBBreak.enabled:= s;
       Break1.enabled:= s;
       PopUpBreak1.enabled:= s;

     end;
   Application.ProcessMessages;
end;

{**************}
{Generate Codes}
{**************}


function GenCode(var success:boolean):AnsiString;
var
  svModified:boolean;
begin
    result:='';
    success:=false;
    EXLINEAppear:=false;
    DebugVariables.clear;

    BreakFlags.LongFlag:=false;
    bkDirective:=bkStep;
   if TextHand.memo<>nil then exit;   {再入防止}
   TextHand.memo:=FrameForm.memo1;
   ChainFile:='';

   MergedLineNumber:=-1;

   svModified:=FrameForm.Memo1.Modified;

   if permitMicrosoft then
      InitialPrecisionMode:=PrecisionNative
   else
      InitialPrecisionMode:=InitialPrecisionMode0;
   initialCharacterByte:=initialCharacterByte0;

   nextGraphMode:=ScreenBitMapMode;   // Linux版のための設定

   IdleImmediately;
   try
      try
           InitMemory;
           MemoryManInit;
           //InitRational;

           HelpContext:=0;
           StatusMes.clear;
           FrameForm.StatusBar1.Panels[1].text:=s_OnCompiling;
           //FrameForm.StatusBar1.Panels[1].Bevel:=pbLowered;
           FrameForm.StatusBar1.update;

           if CompilePrg then
              begin
                   if MixedArithmetic then
                        FrameForm.StatusBar1.Panels[1].text:=''
                   else
                        FrameForm.StatusBar1.Panels[1].text:=
                                               precisionText[MainProgram.arithmetic];
                   ProgramOnRunning:= ChangeFileExt(FrameForm.OpenDialog1.FileName,'')+s_OnRuunnig;
                   FrameForm.StatusBar1.Panels[3].text:=s_OnRuunnig;
                   //FrameForm.Caption:=AppTitle + ;
                   FrameForm.StatusBar1.update;
                   FrameForm.Memo1.Modified:=false;

                   try
                     result:=CurrentProgram.Code;
                     success:=true;
                     //FrameForm.Caption:=AppTitle;
                   except
                      on E:ECodeNotYet do
                         begin
                            MessageDlg(E.message , mtWarning, [mbOK],HelpContext) ;
                            SelectLine(Frameform.memo1,E.st.linenumb);
                         end;
                      on E:Exception do
                          ShowMessage(E.message );
                   end;
             end;
           //FrameForm.StatusBar1.Panels[1].Bevel:=pbNone;
         FrameForm.StatusBar1.Panels[1].text:='';
         FrameForm.StatusBar1.Panels[3].text:=statusBarMems3;
      finally
           //currentprogram.ShareVarTableFreeVar;
           currentprogram.deletestatements;
           currentprogram.freeall;
      end;
   except

   end;
   if MergedLineNumber>0 then RemoveMergedText;

   FrameForm.memo1.Modified:=svModified;
   TextHand.memo:=nil;

end;


function Generate(Lines:TStrings):boolean;
begin
    FrameForm.Break1Click(nil);

    SetTranslatingNow(True);
    CodeForm.Caption:=ChangeFileExt(ExtractFileName(FrameForm.OpenDialog1.FileName), '' );
    Lines.text:=GenCode(result);
    SetTranslatingNow(False);
    //result:=true;
end;

function ShellExec(s1,s2:string; opWaitFor:boolean; const CurDir:Ansistring):boolean;
var
   AProcess: TProcess;
begin
   CtrlBreakHit:=false;
   result:=false;
   AProcess := TProcess.Create(FrameForm);
   AProcess.CommandLine :=s1 + ' ' +s2;
   AProcess.CurrentDirectory:=CurDir;
   try
   try
      AProcess.Execute;
      if opWaitFor then
        while Aprocess.running  do
           begin
              Application.processmessages;
              sleep(40);
              if CtrlBreakHit then AProcess.terminate(0);
           end;

      result:=Aprocess.ExitStatus=0;
   finally
      AProcess.Free;
   end;
   except
   end;
end;

{$IFDEF Windows}
function ShellExecEX(const s1,s2:AnsiString; opWaitFor:boolean; const CurDir:AnsiString ):boolean;
var
   tsh : TSHELLEXECUTEINFOA;
   lpdwExitCode:dword;
const verb:string='open';
begin
   CtrlBreakHit:=false;
   with tsh do
      begin
            cbSize:=Sizeof(tsh);
            fmask:=SEE_MASK_NOCLOSEPROCESS; // プロセスハンドルをクローズしない
            WND:=CodeForm.Handle;
            lpVerb:=pchar(verb);   // 'open';
            lpFile:=PChar(s1);
            lpParameters:=Pchar(s2);
            lpDirectory:=PChar(CurDir);
            nShow:=SW_HIDE;
      end;

   result:=ShellExecuteExA(@tsh);
   if result then
      begin
          // hProcessがシグナル状態になるまで待つ
         if opWaitFor then
              while WaitForSingleObject(tsh.hProcess,100)=WAIT_TIMEOUT do
                 begin
                    Application.processmessages;
                    sleep(40);
                    if CtrlBreakHit then TerminateProcess(tsh.hProcess,0);
                 end;
         CloseHandle(tsh.hProcess);
      end ;
end;
{$ELSE}
function ShellExecEX(const s1,s2:AnsiString; opWaitFor:boolean; const CurDir:AnsiString ):boolean;
begin
   result:=ShellExec(s1,s2,opWaitfor, CurDir)
end;
{$ENDIF}

function GetAppPath:string;
var
   AppPath:String;
begin
   Apppath:=ExtractFileDir(application.exename);
   {$IFDEF LclCarbon}
   Apppath:=copy(Apppath, 1,pos('basicAcc.app',Apppath)-2);
   {$ENDIF}
   result:=AppPath;
end;


function MakeFileName:string;
begin
   result:=GetAppPath+'/output/NoName.lpr';
end;

procedure ExecuteFile(const FName:string);
var
   s1,s2:string;
   dir2:string;
begin
  dir2:=ExtractFileDir(frameForm.OpenDialog1.FileName);
  SetCurrentDir(dir2);
  s2:='';
 {$IFDEF Windows}
  s1:=ChangeFileExt(FName,'.exe');
  {$ELSE}
   {$IFDEF LclCarbon}
   s1:='open';
   s2:=ChangeFileExt(FName,'.app');
   //s1:=ChangeFileExt(FName,'.app')+'/Contents/MacOs/NoName';
   {$ELSE}
   s1:=ChangeFileExt(FName,'');
   {$ENDIF}
  {$ENDIF}
  ShellExecEx(PChar(s1),Pchar(s2),true, dir2);     // 実行
end;


function RunCode(CodeForm:TCodeForm):boolean;
var
   s1,s2:string;
   FName:String;
   dir1,{dir2,}dir3:string;
   AppPath:string;
   FPCPath,UnitPath1,UnitPath2,PrintersPath,SynEditPath:string;
   c:boolean;
const
   TargetCPU='i386';
{$IFDEF Windows}
   TargetOS='win32';
   lclType='win32';
{$ENDIF}
{$IFDEF Linux}
   TargetOS='linux';
{$ENDIF}
{$IFDEF Darwin}
   TargetOS='darwin';
{$ENDIF}
{$IFDEF LclGTK}
   lclType='gtk';
{$ENDIF}
{$IFDEF LclGTK2}
   lclType='gtk2';
{$ENDIF}
{$IFDEF LclQt}
   lclType='qt';
{$ENDIF}
{$IFDEF LclCarbon}
   lclType='carbon';
{$ENDIF}

(*
const
    DefaultFPCPath='C:\Lazarus\FPC\2.2.4\bin\i386-win32\fpc.exe';
    DefualtUnitPath1='C:\Lazarus\lcl\units\i386-win32';
    DefaultUnitPath2='C:\Lazarus\lcl\units\i386-win32\win32';
*)
begin
   setExecutingNow(true);
   sleep(40);
   result:=false;

   dir1:=GetCurrentDir;
   //dir2:=ExtractFileDir(frameForm.OpenDialog1.FileName);
  {$IFDEF Windows}
   FPCPath:=PathDialog.DirectoryEdit1.Directory+'\fpc.exe';
  {$ELSE}
   FPCPath:=PathDialog.DirectoryEdit1.Directory+'/fpc';
  {$ENDIF}
   if not FileExists(FPCPath) then
      begin
        showMessage('fpc.exe not found'+EOL+'do setup path');
        exit;
      end;
   Unitpath1:=PathDialog.DirectoryEdit2.Directory
                                         +'/lcl/units/'+TargetCPU+'-'+TargetOS ;
   Unitpath2:=UnitPath1+'/'+LclType;
   PrintersPath:=PathDialog.DirectoryEdit2.Directory
                 +'/components/printers/lib/'+TargetCPU+'-'+TargetOS+'/'+LclType;
   SynEditPath:=PathDialog.DirectoryEdit2.Directory
                 +'/components/synedit/units/'+TargetCPU+'-'+TargetOS;
   AppPath:=GetAppPath;
   Fname:=MakeFileName;
   SysUtils.DeleteFile( ChangeFileExt(FName,'.err'));
   CodeForm.Memo1.Lines.SaveToFile(Fname);

   s1:=FPCPath;                //'C:\Lazarus\FPC\2.2.4\bin\i386-win32\fpc.exe';
   if base0.UseMassArrays then
      s2:=' -dMassArrays'
   else
      s2:='';
   s2:=s2
     +' -Fu'+PrintersPath
     +' -Fu'+SynEditPath
     +' -Fu'+UnitPath1         //'C:\Lazarus\lcl\units\i386-win32'
     +' -Fu'+Unitpath2         //'C:\Lazarus\lcl\units\i386-win32\win32'
     +' -Fu'+AppPath+'/output'
     +' -Fu'+AppPath+'/source'
     +' -Fu'+AppPath
     +' -Fe'+ChangeFileExt(FName,'.err')
     +' -FE'+AppPath+'/output'
   {$IFDEF Windows}
     +' -WG '          // Windows GUI application
     +' -Ooregvar '    // Use registers
   {$ELSE}
     +' -Cs' +IntToStr(SystemStackSize)+' '
   {$ENDIF}
   {$IFDEF Darwin}
     +' -Fl/sw/lib '
     +' -Fl/usr/X11R6/lib '
     +' -Cg- '
   {$ENDIF}
     {$if FPC_FULlVERSION< 20600}
     +' -St+ '         // Allow static keyword in objects
     {$endif}
     +' -Ct+ '         // enables stack Check
     +' -O3 '          // Level 3 optimizations
     +' -v0 '          // Show nothing except errors
     +' -Xs '          // Strip the symbols from the executable.
     +' -dLCL '
     //+' -g -gl -gh -Xg '      // debug
    {$IFDEF LclGTK}
     +' -dLclGTK '
    {$ENDIF}
    {$IFDEF LclGTK2}
     +' -dLclGTK2 '
    {$ENDIF}
    {$IFDEF LclCarbon}
     +' -dLclCarbon -dTimerDraw '
    {$ENDIF}
    {$IFDEF LclQt}
     +' -dLclQt -dTimerDraw '
    {$ENDIF}

     + FName ;

   result:=ShellExec(PChar(s1),PChar(s2),true, dir1);   //fpcでコンパイル
   if result then
      ExecuteFile(Fname)
   else
     begin
        with CodeForm do
          begin
           visible:=True;
           WindowState:=wsNormal;
           BringToFront;
          end;
        ReportForm.memo1.lines.LoadFromFile(ChangeFileExt(FName,'.err'));
        ReportForm.show
     end;
   SetCurrentDir(dir1);
   setExecutingNow(false);
end;

procedure ExecuteImmediately;
var
   dir1:string;
begin
   setExecutingNow(true);
   dir1:=GetCurrentDir;
   sleep(40);
   ExecuteFile(MakeFileName);
   SetCurrentDir(dir1);
   setExecutingNow(false);
end;

procedure noefect;far;  
begin
end;

function dummy:TStatement;far;
begin
   dummy:=nil
end;


begin
  setIndentOption:=noefect;
   setoperation:=noefect;
   setRunOption:=noefect;
   setRunOption2:=noefect;
   setDebug:=noefect;
   changedir:=noefect;
   setLineEndMarker:=noefect;
   setRefferingPath:=noefect;

end.
