unit datalist;
{$IFDEF FPC}
  {$MODE DELPHI}{$H+}
{$ENDIF}

interface

uses
  Classes, SysUtils,
  base,textfile,arrays;

type
  TDataList=Class(TStringList)
     function InputData(ch:TTextDevice;        const kindlist:ansistring;
                        option:IOoptions;      const prompt:AnsiString;
                        timelimit:double;      elapsed: PDouble;
                        insideofWhen:boolean;  RecordSetter:tpRecordSetter;
                        LineNumb:integer                             ):boolean;
                 // recovery を実行すべきとき偽になる。
     function ReadData(ch:TTextDevice;        const kindlist:ansistring;
                        option:IOoptions;      const prompt:AnsiString;
                        timelimit:double;      elapsed: PDouble;
                        insideofWhen:boolean;  RecordSetter:tpRecordSetter;
                        LineNumb:integer                             ):boolean;
                 // recovery を実行すべきとき偽になる。
     function LineInput(ch:TTextDevice;        const kindlist:ansistring;
                        option:IOoptions;      const prompt:AnsiString;
                        timelimit:double;      elapsed: PDouble;
                        insideofWhen:boolean;  RecordSetter:tpRecordSetter;
                        LineNumb:integer                             ):boolean;
                 // recovery を実行すべきとき偽になる。
     function CharacterInput(ch:TTextDevice;        const kindlist:ansistring;
                        option:IOoptions;      const prompt:AnsiString;
                        timelimit:double;      elapsed: PDouble;
                        insideofWhen:boolean;  RecordSetter:tpRecordSetter;
                        LineNumb:integer                             ):boolean;
                 // recovery を実行すべきとき偽になる。
     function InputVarilen(ch:TTextDevice;        const kindlist:ansistring;
                        option:IOoptions;      const prompt:AnsiString;
                        timelimit:double;      elapsed: PDouble;
                        insideofWhen:boolean;  RecordSetter:tpRecordSetter;
                        LineNumb:integer                             ):boolean;
                 // recovery を実行すべきとき偽になる。
     procedure AssignData(a:Array of Const);
     procedure AssignVarilen(a:TArray1);
  end;
implementation

function TDataList.InputData( ch:TTextDevice;       const kindlist:ansistring;
                              option:IOoptions;     const prompt:AnsiString;
                              timelimit:double;     elapsed: PDouble;
                              insideofWhen:boolean; RecordSetter:tpRecordSetter;
                              LineNumb:integer                        ):boolean;
var
  StartTime:Double;
begin
    if TimeLimit<0 then
                    setexception(8402);
    starttime:=now;

    if ch=nil then setexception(7004);
    ch.CheckForInput(option);
    ch.initInput(LineNumb,prompt,now+timelimit/86400. );
    ch.Setpointer(RecordSetter,insideofWhen);
    result:=ch.DataFoundForRead;
    if result then
       ch.InputData(self,kindlist,option);

    if (elapsed <> nil) and (extype<>8401) then
                    elapsed^:=(now-starttime)*86400. ;

end;

function TDataList.readData(  ch:TTextDevice;       const kindlist:ansistring;
                              option:IOoptions;     const prompt:AnsiString;
                              timelimit:double;     elapsed: PDouble;
                              insideofWhen:boolean; RecordSetter:tpRecordSetter;
                              LineNumb:integer                        ):boolean;
var
  StartTime:Double;
begin
    if TimeLimit<0 then
                    setexception(8402);
    starttime:=now;

    if ch=nil then setexception(7004);
    ch.CheckForInput(option);
    //ch.initInput(LineNumb,prompt,now+timelimit/86400. );
    ch.Setpointer(RecordSetter,insideofWhen);
    result:=ch.DataFoundForRead;
    if result then
       ch.ReadData(self,kindlist,option);

    if (elapsed <> nil) and (extype<>8401) then
                    elapsed^:=(now-starttime)*86400. ;

end;

function TDataList.LineInput( ch:TTextDevice;       const kindlist:ansistring;
                              option:IOoptions;     const prompt:AnsiString;
                              timelimit:double;     elapsed: PDouble;
                              insideofWhen:boolean; RecordSetter:tpRecordSetter;
                              LineNumb:integer                        ):boolean;
var
  StartTime:Double;
begin
    if TimeLimit<0 then
                    setexception(8402);
    starttime:=now;

    if ch=nil then setexception(7004);
    ch.CheckForInput(option);
    ch.initInput(LineNumb,prompt,now+timelimit/86400. );
    ch.Setpointer(RecordSetter,insideofWhen);
    result:=ch.DataFoundForRead;
    if result then
       ch.LineInput(self,length(kindlist),option);

    if (elapsed <> nil) and (extype<>8401) then
                    elapsed^:=(now-starttime)*86400. ;

end;

function TDataList.CharacterInput( ch:TTextDevice;       const kindlist:ansistring;
                              option:IOoptions;     const prompt:AnsiString;
                              timelimit:double;     elapsed: PDouble;
                              insideofWhen:boolean; RecordSetter:tpRecordSetter;
                              LineNumb:integer                        ):boolean;
var
  StartTime:Double;
  s:string;
begin
    if TimeLimit<0 then
                    setexception(8402);
    starttime:=now;

    if ch=nil then setexception(7004);
    ch.CheckForInput(option);
    ch.initInput(LineNumb,prompt,now+timelimit/86400. );
    ch.Setpointer(RecordSetter,insideofWhen);
    result:=ch.DataFoundForRead;
    if result then
       begin
         ch.CharacterInput(s,option);
         self.add(s);
         if (ioNoWait in option) and (s='') then
            begin
              base.extype:=0;  // exception発生を抑止
              result:=false;
            end;
       end;

    if (elapsed <> nil) and (extype<>8401) then
                    elapsed^:=(now-starttime)*86400. ;


end;

function TDataList.InputVarilen( ch:TTextDevice;       const kindlist:ansistring;
                              option:IOoptions;     const prompt:AnsiString;
                              timelimit:double;     elapsed: PDouble;
                              insideofWhen:boolean; RecordSetter:tpRecordSetter;
                              LineNumb:integer                        ):boolean;
var
  StartTime:Double;
  count:integer;
begin
    if TimeLimit<0 then
                    setexception(8402);
    starttime:=now;

    if ch=nil then setexception(7004);
    ch.CheckForInput(option);
    ch.initInput(LineNumb,prompt,now+timelimit/86400. );
    ch.Setpointer(RecordSetter,insideofWhen);
    result:=ch.DataFoundForRead;
    if result then
       ch.InputVarilen(self,kindlist,option,count);

    if (elapsed <> nil) and (extype<>8401) then
                    elapsed^:=(now-starttime)*86400. ;

end;

procedure TDataList.AssignData(a:Array of Const); //aはTArrayの配列
var
   p:integer;
   i:integer;
begin
   p:=0;
   for i:=0 to HIGH(a) do
     with a[i] do
        case VType of
        vtObject:(VObject as TArray).read(self,p);
    end;
end;

procedure TDataList.AssignVarilen(a:TArray1);
begin
  a.AssignVarilen(self)
end;


end.

