unit SetPath;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  EditBtn, StdCtrls, Buttons;

type

  { TPathDialog }

  TPathDialog = class(TForm)
    CancelButton: TButton;
    OkButton1: TButton;
    DirectoryEdit1: TDirectoryEdit;
    DirectoryEdit2: TDirectoryEdit;
    Label1: TLabel;
    Label2: TLabel;
    OpenDialog1: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { private declarations }
  public
    procedure execute;
  end; 

var
  PathDialog: TPathDialog;

implementation
uses base,base0;
{$R *.lfm}

 { TPathDialog }

procedure TPathDialog.FormCreate(Sender: TObject);
var
   p:integer;
begin
  with TMyIniFile.create('Path') do
    begin
     {$IFDEF Windows}
      with  DirectoryEdit1 do Directory:=ReadString('Path1','C:\Lazarus\fpc\2.6.0\bin\i386-win32');
      with  DirectoryEdit2 do Directory:=ReadString('Path2','C:\Lazarus');
     {$ENDIF}
     {$IFDEF Linux}
      with  DirectoryEdit1 do Directory:=ReadString('Path1','/usr/bin');
      with  DirectoryEdit2 do Directory:=ReadString('Path2','/usr/lib/lazarus');
     {$ENDIF}
     {$IFDEF Darwin}
      with  DirectoryEdit1 do Directory:=ReadString('Path1','/usr/local/bin');
      with  DirectoryEdit2 do Directory:=ReadString('Path2','/Developer/lazarus');
     {$ENDIF}
      free
    end;
   // ver. 0.9.1に上書きの場合の処理
   p:=Pos('\lcl\units\',DirectoryEdit2.Directory);
   if p>0 then
      with DirectoryEdit2 do
        Directory:=Copy(Directory,1,p-1);
end;


procedure TPathDialog.FormDestroy(Sender: TObject);
begin
  with TMyIniFile.create('Path') do
      begin
          WriteString('Path1',DirectoryEdit1.Directory);
          WriteString('Path2',DirectoryEdit2.Directory);
          Free
      end;
end;

procedure TPathDialog.execute;
var
  bk1,bk2:TFileName;
begin
   bk1:= DirectoryEdit1.Directory;
   bk2:= DirectoryEdit2.Directory;
   if showModal<>mrOk then
      begin
         DirectoryEdit1.Directory := bk1;
         DirectoryEdit2.Directory := bk2;
      end;
end;

initialization



finalization


end.

