unit setupop;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, ComCtrls;

type

  { TSetUpOptionsDlg }

  TSetUpOptionsDlg = class(TForm)
    Button1: TButton;
    CancelBtn: TButton;
    CheckBox1: TCheckBox;
    OptimInteger: TCheckBox;
    OptimDouble: TCheckBox;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    procedure CheckBox1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
  private
    procedure rearrange;
  public
    procedure execute;
  end; 

var
  SetUpOptionsDlg: TSetUpOptionsDlg;

implementation
{ TSetUpOptionsDlg }
uses base0;
{$R *.lfm}



procedure TSetUpOptionsDlg.execute;
begin
    CheckBox1.Checked := UseMassArrays;
    OptimInteger.checked:=OptimizeInteger;
    OptimDouble.checked:=OptimizeDouble;
    TrackBar1.Position:= SystemStackSize div (4 * 1048576) ;
    TrackBar2.Position:= VirtualStackSize div (16 * 1048576) ;
    if showModal =mrOk then
      begin
           SystemStackSize:=TrackBar1.Position* 4 * 1048576;
           VirtualStackSize:=Trackbar2.Position* 16 * 1048576;
           OptimizeInteger := OptimInteger.checked;
           OptimizeDouble  := OptimDouble.checked;
           if UseMassArrays<>CheckBox1.Checked then
             begin
               UseMassArrays:=CheckBox1.Checked;
               SysUtils.DeleteFile(ExtractFileDir(application.exename)+'\output\vstack.ppu');
               SysUtils.DeleteFile(ExtractFileDir(application.exename)+'\output\vstack.o');
               SysUtils.DeleteFile(ExtractFileDir(application.exename)+'\output\arrays.ppu');
               SysUtils.DeleteFile(ExtractFileDir(application.exename)+'\output\arrays.o');
             end;
      end;
end;

procedure TSetUpOptionsDlg.FormShow(Sender: TObject);
begin
   TrackBar1Change(Sender);
   TrackBar2Change(Sender);
end;




procedure TSetUpOptionsDlg.TrackBar1Change(Sender: TObject);
begin
   Label1.caption:=IntToStr(TrackBar1.position * 4);
   ReArrange;
end;

procedure TSetUpOptionsDlg.TrackBar2Change(Sender: TObject);
begin
   ReArrange;
   Label3.caption:=IntToStr(TrackBar2.position * 16);
end;

procedure TSetUpOptionsDlg.ReArrange;
var
  mem1,mem2:cardinal;
begin
  mem1:= TrackBar1.position  * 4 * 1048576;
  mem2:= TrackBar2.position * 16* 1048576;
  if mem1+mem2>1920 * 1048576  then
    begin
       mem2:=1920*1048576-mem1;
       TrackBar2.position:=mem2 div (16 * 1048576) ;

    end;

end;

procedure TSetUpOptionsDlg.CheckBox1Change(Sender: TObject);
begin
   Label6.visible:=CheckBox1.checked;
end;

procedure TSetUpOptionsDlg.FormCreate(Sender: TObject);
begin
  {$IFNDEF Windows}
    TrackBar1.Enabled:=false;
  {$ENDIF}
end;



initialization

end.

