unit Winlib;

{$IFDEF FPC}
  {$MODE DELPHI} {$H+}
{$ENDIF}

interface

uses
  Classes, SysUtils, Forms,Windows,  mmsystem,
  base,float;

function Assign(const DLLName,FUNCName:string; a:array of const):Cardinal;
function AssignFPU(const DLLName,FUNCName:string; a:array of const):extended;
function WinHandle(const form:string):integer;
function PlaySound(const s:ansistring; async:boolean):LongBool;
function Play(const s:ansistring; async:boolean):LongBool;    //関連付けでPlay

implementation
 uses controls, fileutil ,shellapi
 ,textfrm,locatefrm,locatech,paintfrm,inputdlg,charinp;

const DLL_Error=-9900;
type
    PPointerArray=^TPointerArray;
    TPointerArray=array[0..7] of pointer;
    TLongIntFunction=function:LongInt;
    TFPUFunction=function:extended;

Function RoundToLongint(x:extended):longint;assembler;
asm
    PUSH EDX
    PUSH EAX
    FLD x
    FISTP QWORD PTR [ESP]
    WAIT
    POP EAX
    POP EDX
end;

function Assign(const DLLName,FUNCName:string; a:array of const):cardinal;
var
  handle:THandle;
  ProcAddr:TLongIntFunction;
  params:PPointerArray;
  i:integer;
  p:pointer;
begin
   Handle:=LoadLibrary(PChar(ExtractFilePath(Application.ExeName)+DLLName));
  if Handle=0 then
     Handle:=LoadLibrary(PChar(DLLName));
  if (Handle=0) then
     SetExceptionWith(DLLName+' Not Found',DLL_Error);

  @ProcAddr:=GetProcAddress(Handle,PChar(FuncName));
  if @ProcAddr=nil then
                 SetExceptionWith(FuncName+' Not Found',DLL_Error);

  params:=AllocMem(sizeof(pointer)*Length(a));
  try
    for i:=0 to High(a) do
     with a[i] do
      begin
       case VTYPE of
        VTINTEGER:   longint(params^[i]):=VInteger;
        VTInt64:     Cardinal(params^[i]):=VINT64^;
        VTExtended:  longint(params^[i]):=RoundToLongint(VExtended^);
        vtAnsistring:params^[i]:=PChar(VAnsistring);
       else
        setexceptionWith(IntToStr(i)+'th Parameter imcompatible',Dll_Error);
       end;
      end;


     try
       for i:=high(a) downto 0 do
         begin
           p:=@params^[i];
           asm
             mov eax, p
             push dword ptr [eax]
           end;
         end;

       result:=ProcAddr;
     except
      on E:EExtype do
         raise;
      else
         SetException(DLL_Error)
     end;

  finally
     FreeMem(params,sizeof(pointer)*Length(a));
  end;

end;

function AssignFPU(const DLLName,FUNCName:string; a:array of const):extended;
var
  handle:THandle;
  ProcAddrX:TFPUFunction;
  params:PPointerArray;
  i:integer;
  p:pointer;
begin
   Handle:=LoadLibrary(PChar(ExtractFilePath(Application.ExeName)+DLLName));
  if Handle=0 then
     Handle:=LoadLibrary(PChar(DLLName));
  if (Handle=0) then
     SetExceptionWith(DLLName+' Not Found',DLL_Error);

  @ProcAddrX:=GetProcAddress(Handle,PChar(FuncName));
  if @ProcAddrX=nil then
                 SetExceptionWith(FuncName+' Not Found',DLL_Error);

  params:=AllocMem(sizeof(pointer)*Length(a));
  try
    for i:=0 to High(a) do
     with a[i] do
      begin
       case VTYPE of
        VTINTEGER:   longint(params^[i]):=VInteger;
        VTInt64:     Cardinal(params^[i]):=VINT64^;
        VTExtended:  longint(params^[i]):=RoundToLongint(VExtended^);
        vtAnsistring:params^[i]:=PChar(VAnsistring);
       else
        setexceptionWith(IntToStr(i)+'th Parameter imcompatible',Dll_Error);
       end;
      end;


     try
       for i:=high(a) downto 0 do
         begin
           p:=@params^[i];
           asm
             mov eax, p
             push dword ptr [eax]
           end;
         end;

       result:=ProcAddrX;
     except
      on E:EExtype do
         raise;
      else
         SetException(DLL_Error)
     end;

  finally
     FreeMem(params,sizeof(pointer)*Length(a));
  end;

end;

function WinHandle(const form:string):integer;
var
   s:string;
   w:TWinControl;
begin
   s:=uppercase(form);

   if s='MAIN' then
      w:=Application.mainForm
   else if s='TEXT' then
      w:=TextForm
   else if s='GRAPHICS' then
      w:=PaintForm
   else {if s='TRACE' then
      w:=TraceForm
   else} if s='INPUT' then
      w:=InputDialog
   else if s='CHARACTER INPUT' then
      w:=CharInput
   else if (s='LOCATE') or (s='LOCATEVALUE') then
      w:=LocateForm
   else if s='LOCATECHOICE' then
      w:=LocateChoiceForm
   else
      w:=nil;
   if w<>nil then
      result:=w.Handle
   else
      result:=0
end;


{
Function PlaySoundA(x1: LPCSTR; x2: HMODULE; x3: DWORD): BOOL; stdcall;
                                        external 'winmm.dll' name 'PlaySoundA';
Function mciSendStringA(x1: LPCSTR; x2: LPSTR; x3: UINT; x4: HWND): DWORD;stdcall;
                                    external 'winmm.dll' name 'mciSendStringA';
}

function PlaySound(const s:ansistring; async:boolean):LongBool;
begin
  result:=PlaySoundA(Pchar(UTF8ToSys(s)),0,$20000+ORD(Async))
end;

function ShellExec(const s1,s2,verb:AnsiString; opWaitFor:boolean; state:integer ):longbool;
var
   tsh : TSHELLEXECUTEINFOA;
   lpdwExitCode:dword;
begin
   IdleImmediately;
   with tsh do
      begin
            cbSize:=Sizeof(tsh);
            fmask:=SEE_MASK_NOCLOSEPROCESS; // プロセスハンドルをクローズしない
            WND:=TextForm.Handle;
            lpVerb:=pchar(verb);   // open';
            lpFile:=PChar(s1);
            lpParameters:=Pchar(s2);
            lpDirectory:='';
            nShow:=state ;//SW_SHOW;
      end;
   result:=ShellExecuteExA(@tsh);
   if result then
      begin
          // hProcessがシグナル状態になるまで待つ
         if opWaitFor then
               WaitForSingleObject(tsh.hProcess,INFINITE);
         CloseHandle(tsh.hProcess);
      end ;
   IdleImmediately;
end;

function Play(const s:ansistring; async:boolean):LongBool;    //関連付けでPlay
begin
   result:= ShellExec(UTF8ToSys(s),'', 'Play', not async, sw_ShowNormal)
end;

end.

